declare type AnyFunction = (...args: any[]) => any;
interface AnyClass {
    new (...args: any[]): any;
    [x: number]: any;
    [y: string]: any;
}
export declare type AnyObject = Record<string | number, any>;
export declare type Provide = string | AnyObject;
export declare type ProvideValue = AnyObject;
export declare type Provider = AnyClass | {
    provide: Provide;
    useClass?: AnyClass | null;
    useValue?: ProvideValue | null;
    dispose?: AnyFunction | null;
};
export declare type ProviderRecord = {
    value: ProvideValue | null;
    useClass?: AnyClass | null;
    dispose?: AnyFunction | null;
};
export declare type ProviderRecords = Map<Provide, ProviderRecord>;
export default class Injector {
    private parent;
    private records;
    constructor(providers?: Provider[], parent?: Injector | null);
    isRegistered(provide: Provide): boolean;
    get(provide: Provide): ProvideValue;
    private $_initClass;
    dispose(): void;
    static getParentInjector(instance: InstanceType<AnyClass>): Injector | null;
}
export {};
