import React from 'react';
import Injector, { Provide, ProvideValue, Provider } from '../core/injector';
declare type GetService = (provide: Provide) => ProvideValue;
declare type ProviderProps = {
    providers: Provider[];
    children: React.ReactNode;
};
declare type ConsumerProps = {
    provides: Provide[];
    children?: (services: ProvideValue[], getService: GetService) => React.ReactNode;
};
declare const Context: React.Context<Injector>;
declare const Provider: (props: ProviderProps) => React.ReactElement;
declare const Consumer: (props: ConsumerProps) => React.ReactNode;
export { Context, Provider, Consumer };
